__  __    __   __  _____      _            _          _____ _          _ _ 
 |  \/  |   \ \ / / |  __ \    (_)          | |        / ____| |        | | |
 | \  / |_ __\ V /  | |__) | __ ___   ____ _| |_ ___  | (___ | |__   ___| | |
 | |\/| | '__|> <   |  ___/ '__| \ \ / / _` | __/ _ \  \___ \| '_ \ / _ \ | |
 | |  | | |_ / . \  | |   | |  | |\ V / (_| | ||  __/  ____) | | | |  __/ | |
 |_|  |_|_(_)_/ \_\ |_|   |_|  |_| \_/ \__,_|\__\___| |_____/|_| |_|\___V 2.1
 if you need WebShell for Seo everyday contact me on Telegram
 Telegram Address : @jackleet
        
        
For_More_Tools: Telegram: @jackleet | Bulk Smtp support mail sender | Business Mail Collector | Mail Bouncer All Mail | Bulk Office Mail Validator | Html Letter private



Upload:

Command:

[email protected]: ~ $
#!/bin/bash
# SPDX-License-Identifier: GPL-2.0
#
# Testing For IPv4 and IPv6 BIG TCP.
# TOPO: CLIENT_NS (link0)<--->(link1) ROUTER_NS (link2)<--->(link3) SERVER_NS

CLIENT_NS=$(mktemp -u client-XXXXXXXX)
CLIENT_IP4="198.51.100.1"
CLIENT_IP6="2001:db8:1::1"

SERVER_NS=$(mktemp -u server-XXXXXXXX)
SERVER_IP4="203.0.113.1"
SERVER_IP6="2001:db8:2::1"

ROUTER_NS=$(mktemp -u router-XXXXXXXX)
SERVER_GW4="203.0.113.2"
CLIENT_GW4="198.51.100.2"
SERVER_GW6="2001:db8:2::2"
CLIENT_GW6="2001:db8:1::2"

MAX_SIZE=128000
CHK_SIZE=65535

# Kselftest framework requirement - SKIP code is 4.
ksft_skip=4

setup() {
	ip netns add $CLIENT_NS
	ip netns add $SERVER_NS
	ip netns add $ROUTER_NS
	ip -net $ROUTER_NS link add link1 type veth peer name link0 netns $CLIENT_NS
	ip -net $ROUTER_NS link add link2 type veth peer name link3 netns $SERVER_NS

	ip -net $CLIENT_NS link set link0 up
	ip -net $CLIENT_NS link set link0 mtu 1442
	ip -net $CLIENT_NS addr add $CLIENT_IP4/24 dev link0
	ip -net $CLIENT_NS addr add $CLIENT_IP6/64 dev link0 nodad
	ip -net $CLIENT_NS route add $SERVER_IP4 dev link0 via $CLIENT_GW4
	ip -net $CLIENT_NS route add $SERVER_IP6 dev link0 via $CLIENT_GW6
	ip -net $CLIENT_NS link set dev link0 \
		gro_ipv4_max_size $MAX_SIZE gso_ipv4_max_size $MAX_SIZE
	ip -net $CLIENT_NS link set dev link0 \
		gro_max_size $MAX_SIZE gso_max_size $MAX_SIZE
	ip net exec $CLIENT_NS sysctl -wq net.ipv4.tcp_window_scaling=10

	ip -net $ROUTER_NS link set link1 up
	ip -net $ROUTER_NS link set link2 up
	ip -net $ROUTER_NS addr add $CLIENT_GW4/24 dev link1
	ip -net $ROUTER_NS addr add $CLIENT_GW6/64 dev link1 nodad
	ip -net $ROUTER_NS addr add $SERVER_GW4/24 dev link2
	ip -net $ROUTER_NS addr add $SERVER_GW6/64 dev link2 nodad
	ip -net $ROUTER_NS link set dev link1 \
		gro_ipv4_max_size $MAX_SIZE gso_ipv4_max_size $MAX_SIZE
	ip -net $ROUTER_NS link set dev link2 \
		gro_ipv4_max_size $MAX_SIZE gso_ipv4_max_size $MAX_SIZE
	ip -net $ROUTER_NS link set dev link1 \
		gro_max_size $MAX_SIZE gso_max_size $MAX_SIZE
	ip -net $ROUTER_NS link set dev link2 \
		gro_max_size $MAX_SIZE gso_max_size $MAX_SIZE
	# test for nf_ct_skb_network_trim in nf_conntrack_ovs used by TC ct action.
	ip net exec $ROUTER_NS tc qdisc add dev link1 ingress
	ip net exec $ROUTER_NS tc filter add dev link1 ingress \
		proto ip flower ip_proto tcp action ct
	ip net exec $ROUTER_NS tc filter add dev link1 ingress \
		proto ipv6 flower ip_proto tcp action ct
	ip net exec $ROUTER_NS sysctl -wq net.ipv4.ip_forward=1
	ip net exec $ROUTER_NS sysctl -wq net.ipv6.conf.all.forwarding=1

	ip -net $SERVER_NS link set link3 up
	ip -net $SERVER_NS addr add $SERVER_IP4/24 dev link3
	ip -net $SERVER_NS addr add $SERVER_IP6/64 dev link3 nodad
	ip -net $SERVER_NS route add $CLIENT_IP4 dev link3 via $SERVER_GW4
	ip -net $SERVER_NS route add $CLIENT_IP6 dev link3 via $SERVER_GW6
	ip -net $SERVER_NS link set dev link3 \
		gro_ipv4_max_size $MAX_SIZE gso_ipv4_max_size $MAX_SIZE
	ip -net $SERVER_NS link set dev link3 \
		gro_max_size $MAX_SIZE gso_max_size $MAX_SIZE
	ip net exec $SERVER_NS sysctl -wq net.ipv4.tcp_window_scaling=10
	ip net exec $SERVER_NS netserver 2>&1 >/dev/null
}

cleanup() {
	ip net exec $SERVER_NS pkill netserver
	ip -net $ROUTER_NS link del link1
	ip -net $ROUTER_NS link del link2
	ip netns del "$CLIENT_NS"
	ip netns del "$SERVER_NS"
	ip netns del "$ROUTER_NS"
}

start_counter() {
	local ipt="iptables"
	local iface=$1
	local netns=$2

	[ "$NF" = "6" ] && ipt="ip6tables"
	ip net exec $netns $ipt -t raw -A PREROUTING -i $iface \
		-m length ! --length 0:$CHK_SIZE -j ACCEPT
}

check_counter() {
	local ipt="iptables"
	local iface=$1
	local netns=$2

	[ "$NF" = "6" ] && ipt="ip6tables"
	test `ip net exec $netns $ipt -t raw -L -v |grep $iface | awk '{print $1}'` != "0"
}

stop_counter() {
	local ipt="iptables"
	local iface=$1
	local netns=$2

	[ "$NF" = "6" ] && ipt="ip6tables"
	ip net exec $netns $ipt -t raw -D PREROUTING -i $iface \
		-m length ! --length 0:$CHK_SIZE -j ACCEPT
}

do_netperf() {
	local serip=$SERVER_IP4
	local netns=$1

	[ "$NF" = "6" ] && serip=$SERVER_IP6

	# use large write to be sure to generate big tcp packets
	ip net exec $netns netperf -$NF -t TCP_STREAM -l 1 -H $serip -- -m 262144 2>&1 >/dev/null
}

do_test() {
	local cli_tso=$1
	local gw_gro=$2
	local gw_tso=$3
	local ser_gro=$4
	local ret="PASS"

	ip net exec $CLIENT_NS ethtool -K link0 tso $cli_tso
	ip net exec $ROUTER_NS ethtool -K link1 gro $gw_gro
	ip net exec $ROUTER_NS ethtool -K link2 tso $gw_tso
	ip net exec $SERVER_NS ethtool -K link3 gro $ser_gro

	start_counter link1 $ROUTER_NS
	start_counter link3 $SERVER_NS
	do_netperf $CLIENT_NS

	if check_counter link1 $ROUTER_NS; then
		check_counter link3 $SERVER_NS || ret="FAIL_on_link3"
	else
		ret="FAIL_on_link1"
	fi

	stop_counter link1 $ROUTER_NS
	stop_counter link3 $SERVER_NS
	printf "%-9s %-8s %-8s %-8s: [%s]\n" \
		$cli_tso $gw_gro $gw_tso $ser_gro $ret
	test $ret = "PASS"
}

testup() {
	echo "CLI GSO | GW GRO | GW GSO | SER GRO" && \
	do_test "on"  "on"  "on"  "on"  && \
	do_test "on"  "off" "on"  "off" && \
	do_test "off" "on"  "on"  "on"  && \
	do_test "on"  "on"  "off" "on"  && \
	do_test "off" "on"  "off" "on"
}

if ! netperf -V &> /dev/null; then
	echo "SKIP: Could not run test without netperf tool"
	exit $ksft_skip
fi

if ! ip link help 2>&1 | grep gso_ipv4_max_size &> /dev/null; then
	echo "SKIP: Could not run test without gso/gro_ipv4_max_size supported in ip-link"
	exit $ksft_skip
fi

trap cleanup EXIT
setup && echo "Testing for BIG TCP:" && \
NF=4 testup && echo "***v4 Tests Done***" && \
NF=6 testup && echo "***v6 Tests Done***"
exit $?

Filemanager

Name Type Size Permission Actions
af_unix Folder 0755
forwarding Folder 0755
hsr Folder 0755
lib Folder 0755
mptcp Folder 0755
netfilter Folder 0755
openvswitch Folder 0755
packetdrill Folder 0755
rds Folder 0755
tcp_ao Folder 0755
Makefile File 4.82 KB 0644
altnames.sh File 1.77 KB 0755
amt.sh File 9.2 KB 0755
arp_ndisc_evict_nocarrier.sh File 5.15 KB 0755
arp_ndisc_untracked_subnets.sh File 7.04 KB 0755
bareudp.sh File 20.79 KB 0755
big_tcp.sh File 5.49 KB 0755
bind_bhash.sh File 1.34 KB 0755
busy_poll_test.sh File 3.47 KB 0755
cmsg_ipv6.sh File 3.34 KB 0755
cmsg_so_mark.sh File 1.54 KB 0755
cmsg_so_priority.sh File 3.93 KB 0755
cmsg_time.sh File 2.22 KB 0755
drop_monitor_tests.sh File 4.34 KB 0755
fcnal-test.sh File 106.62 KB 0755
fdb_flush.sh File 21.04 KB 0755
fdb_notify.sh File 1.81 KB 0755
fib-onlink-tests.sh File 12.04 KB 0755
fib_nexthop_multiprefix.sh File 5.81 KB 0755
fib_nexthop_nongw.sh File 2.19 KB 0755
fib_nexthops.sh File 73.9 KB 0755
fib_rule_tests.sh File 17.66 KB 0755
fib_tests.sh File 77.47 KB 0755
fin_ack_lat.sh File 507 B 0755
fq_band_pktlimit.sh File 1.81 KB 0755
gre_gso.sh File 4.04 KB 0755
gro.sh File 2.27 KB 0755
icmp.sh File 2.52 KB 0755
icmp_redirect.sh File 12.49 KB 0755
in_netns.sh File 323 B 0755
io_uring_zerocopy_tx.sh File 3 KB 0755
ioam6.sh File 50.49 KB 0755
ip6_gre_headroom.sh File 1.37 KB 0755
ip_defrag.sh File 2.04 KB 0755
ip_local_port_range.sh File 153 B 0755
ipv6_flowlabel.sh File 1 KB 0755
ipv6_route_update_soft_lockup.sh File 10.8 KB 0755
l2_tos_ttl_inherit.sh File 13.95 KB 0755
l2tp.sh File 9.68 KB 0755
lib.sh File 8.65 KB 0644
lwt_dst_cache_ref_loop.sh File 5.94 KB 0755
msg_zerocopy.sh File 2.93 KB 0755
ndisc_unsolicited_na_test.sh File 5.85 KB 0755
net_helper.sh File 514 B 0644
netdevice.sh File 5.69 KB 0755
netns-name.sh File 2.4 KB 0755
netns-sysctl.sh File 910 B 0755
pmtu.sh File 78.42 KB 0755
psock_snd.sh File 2.2 KB 0755
reuseaddr_ports_exhausted.sh File 635 B 0755
reuseport_addr_any.sh File 81 B 0755
route_localnet.sh File 1.92 KB 0755
rps_default_mask.sh File 2.19 KB 0755
rtnetlink.sh File 35.16 KB 0755
rxtimestamp.sh File 79 B 0755
sctp_vrf.sh File 5.81 KB 0755
setup_loopback.sh File 2.7 KB 0644
setup_veth.sh File 1.01 KB 0644
so_txtime.sh File 2.71 KB 0755
srv6_end_dt46_l3vpn_test.sh File 20.57 KB 0755
srv6_end_dt4_l3vpn_test.sh File 16.92 KB 0755
srv6_end_dt6_l3vpn_test.sh File 17.11 KB 0755
srv6_end_dx4_netfilter_test.sh File 10.92 KB 0755
srv6_end_dx6_netfilter_test.sh File 11.13 KB 0755
srv6_end_flavors_test.sh File 23.56 KB 0755
srv6_end_next_csid_l3vpn_test.sh File 32.53 KB 0755
srv6_end_x_next_csid_l3vpn_test.sh File 35.46 KB 0755
srv6_hencap_red_l3vpn_test.sh File 23.15 KB 0755
srv6_hl2encap_red_l2vpn_test.sh File 20.51 KB 0755
stress_reuseport_listen.sh File 539 B 0755
tcp_fastopen_backup_key.sh File 1.06 KB 0755
test_blackhole_dev.sh File 280 B 0755
test_bpf.sh File 225 B 0755
test_bridge_backup_port.sh File 27.35 KB 0755
test_bridge_neigh_suppress.sh File 28.4 KB 0755
test_ingress_egress_chaining.sh File 2.14 KB 0644
test_vxlan_fdb_changelink.sh File 678 B 0755
test_vxlan_mdb.sh File 92.63 KB 0755
test_vxlan_nolocalbypass.sh File 5.57 KB 0755
test_vxlan_under_vrf.sh File 5.54 KB 0755
test_vxlan_vnifiltering.sh File 20.91 KB 0755
toeplitz.sh File 4.87 KB 0755
toeplitz_client.sh File 667 B 0755
traceroute.sh File 6.91 KB 0755
txtimestamp.sh File 1.84 KB 0755
udpgro.sh File 5.72 KB 0755
udpgro_bench.sh File 2.08 KB 0755
udpgro_frglist.sh File 2.43 KB 0755
udpgro_fwd.sh File 7.08 KB 0755
udpgso.sh File 2.42 KB 0755
udpgso_bench.sh File 2.83 KB 0755
unicast_extensions.sh File 7.77 KB 0755
veth.sh File 10.75 KB 0755
vlan_bridge_binding.sh File 4.49 KB 0755
vlan_hw_filter.sh File 819 B 0755
vrf-xfrm-tests.sh File 10.65 KB 0755
vrf_route_leaking.sh File 16.48 KB 0755
vrf_strict_mode_test.sh File 8 KB 0755
xfrm_policy.sh File 14.65 KB 0755
xfrm_policy_add_speed.sh File 1.51 KB 0755
Filemanager